
let rec print l = match l with
  | [] -> print_newline ()
  | x :: r -> let _ = print_int x in let _ = print_string ";" in print r

let rec append l1 l2 = match l1 with
  | [] -> l2
  | x :: xs -> x :: append xs l2

let _ = print (append [1;2;3] [])
let _ = print (append [] [1;2;3])
let _ = print (append [1;2;3] [4])
let _ = print (append [1] [2;3;4])
let _ = print (append [1;2;3] [4;5;6])
