
let rec fold_right f l acc = match l with
  | [] -> acc
  | x :: r -> f x (fold_right f r acc)

let plus x y = x + y

let x = fold_right plus [1;2;3;4] 0
let _ = print_int x
let _ = print_newline ()

let _ = print_int (fold_right plus [] 42)
let _ = print_newline ()
