
let rec print l = match l with
  | [] -> print_newline ()
  | x :: r -> let _ = print_int x in let _ = print_string ";" in print r

let _ = print [1;2;3;4]

let rec insertion x l = match l with
  | [] -> [x]
  | y :: r -> if x <= y then x :: l else y :: insertion x r

let rec insertion_sort l = match l with
  | [] -> [] 
  | x :: l -> insertion x (insertion_sort l)

let _ = print (insertion_sort [4;3;2;1])
