
let rev l =
  let rec rev_aux acc l = match l with
    | [] -> acc
    | x :: r -> rev_aux (x :: acc) r
  in 
  rev_aux [] l

let rec print l = match l with
  | [] -> print_newline ()
  | x :: r -> let _ = print_int x in let _ = print_string ";" in print r

let _ = print (rev [])
let _ = print (rev [1])
let _ = print (rev [1;2;3;4])

let rev2 =
  let rec rev_aux acc l = match l with
    | [] -> acc
    | x :: r -> rev_aux (x :: acc) r
  in 
  rev_aux []

let _ = print (rev2 [])
let _ = print (rev2 [1])
let _ = print (rev2 [1;2;3;4])


