
let empty = []

let push x st = x :: st

let null = (-1, [])

let pop st = match st with
  | [] -> null
  | x :: st -> (x, st)

let rec print l = match l with
  | [] -> print_newline ()
  | x :: r -> let _ = print_int x in let _ = print_string ";" in print r

let st = push 1 (push 2 (push 3 (push 4 empty)))
let _ = print st
let _ = let (_,st) = pop st in print st

let fst (x,_) = x
let snd (_,x) = x

let _ = print (snd (pop st))



